function area = computeProjectionAreaVrep(vrep, dirMatrix, zerotol)
% projection area of a V-polytope
%
% Syntax: area = computeProjectionAreaVrep(vrep, dirMatrix)
%
% This function calculates a vector of projection areas for all directions
%   in dirMatrix that contains one direction in each row.
%
% computeProjectionAreaVrep(..., zerotol) allows to set the tolerance for 
%   underlying algorithms (e.g. determining flat polytopes; default in
%   elkZerotol).
%
% See also: computeProjectionAreaHrep, computeVolumeVrep,
%   computeFacetAreaVrep, computeFeretVrep, computeSupportValueVrep

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Input handling
% default zerotol
if ~exist('zerotol', 'var')
    zerotol = elkZerotol;
end

% check dimension
if size(vrep.V, 2) == 3
    % everything OK, that is the normal case
elseif size(vrep.V, 2) == 2
    % we use the maximum and minimum projection onto the given line
    % normalize dir matrix
    dirMatrix = bsxfun(@times, ...
        1./sqrt(sum(dirMatrix.^2, 2)), ...
        dirMatrix);
    projectionLengthVector = dirMatrix * vrep.V';
    area = max(projectionLengthVector, [], 2) - min(projectionLengthVector, [], 2);
    return
elseif size(vrep.V, 2) == 1
    % this is trivial
    area = 0;
    return
else
    error('elk:polytope:inputError', ...
          'Only three dimensional polytopes can be handled');
end

%% do for each facet
area = zeros(1,size(dirMatrix, 1));
for iFacet = 1:size(dirMatrix, 1)
    % Get support set in direction
    projectedVrep = projectVrep3d(vrep, dirMatrix(iFacet, :));
    % Calculate volume of support set (2-D Volume)
    area(iFacet) = computeVolumeVrep(projectedVrep, zerotol);
end